/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.24 from the
 * contents of SongChange.xs. Do not edit this file, edit SongChange.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "SongChange.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "xmms/xmmsctrl.h"
#include "pthread.h"

typedef struct {
    pthread_t thread;
    pthread_mutex_t mutex;
    gint prev_song;
    gint prev_len;
    gint session;
    GHashTable *jtime;
    GHashTable *repeat;
    GHashTable *crop;
    //GHashTable *fade;
#ifdef PERL_SC_HANDLERS
    AV *handlers;
#endif
} sc;

typedef struct {
    gint pos;
    gint num;
    gint counter;
} sc_repeat;

typedef gint Xmms__Remote;
typedef sc * Xmms__SongChange;

#define sc_lock(obj) \
pthread_mutex_lock(&obj->mutex)

#define sc_unlock(obj) \
pthread_mutex_unlock(&obj->mutex)

static gint string_to_time(char *timestr)
{
    gint mm, ss;
    if (sscanf(timestr, "%d:%d", &mm, &ss) == 2) {
	return (mm * 60000) + (ss * 1000);
    }
    return 0;
}

static void time_to_string(gint length, char *timestr)
{
    sprintf(timestr, "%d:%-2.2d", length/60000, (length/1000) % 60);
}

static void sc_hash_store(sc *obj, GHashTable *tab, gpointer key, gpointer val)
{
    sc_lock(obj);
    g_hash_table_insert(tab, key, val);
    sc_unlock(obj);
}

static gpointer sc_hash_fetch(sc *obj, GHashTable *tab, gpointer key)
{
    gpointer retval;
    sc_lock(obj);
    retval = g_hash_table_lookup(tab, key);
    sc_unlock(obj);
    return retval;
}

#define sc_jtime_FETCH(obj, key) \
(gint)sc_hash_fetch(obj, obj->jtime, (gpointer)key)

#define sc_jtime_STORE(obj, key, val) \
sc_hash_store(obj, obj->jtime, (gpointer)key, \
              (gpointer)string_to_time(val))

#define sc_repeat_FETCH(obj, key) \
(sc_repeat *)sc_hash_fetch(obj, obj->repeat, (gpointer)key)

static void sc_repeat_STORE(sc *obj, gint key, gint val)
{
    sc_repeat *scr = sc_repeat_FETCH(obj, key);
    if (!scr) {
	scr = (sc_repeat *)malloc(sizeof(*scr));
    }
    scr->num = val;
    scr->counter = val;
    scr->pos = key - 1;
    sc_hash_store(obj, obj->repeat, (gpointer)key, (gpointer)scr);
}

#define sc_crop_FETCH(obj, key) \
(gint)sc_hash_fetch(obj, obj->crop, (gpointer)key)

#define sc_crop_STORE(obj, key, val) \
sc_hash_store(obj, obj->crop, (gpointer)key, \
              (gpointer)string_to_time(val))

#define xmms_remote_wait_for_output(session) \
while (!xmms_remote_get_output_time(session)) {}

static void sc_jtime_change(sc *obj, gint *pos)
{
    gint jtime;

    if ((jtime = sc_jtime_FETCH(obj, *pos+1))) {
	xmms_remote_wait_for_output(obj->session);
	xmms_remote_jump_to_time(obj->session, jtime);
    }
}

static void sc_repeat_change(sc *obj, gint *pos)
{
    sc_repeat *scr = sc_repeat_FETCH(obj, *pos);

    if (scr && scr->counter) {
	gint length = xmms_remote_get_playlist_time(obj->session, scr->pos);
	*pos = obj->prev_song = scr->pos;
	obj->prev_len = length;
	--scr->counter;
	xmms_remote_set_playlist_pos(obj->session, scr->pos);
    }

    scr = sc_repeat_FETCH(obj, *pos);
    if (scr && !scr->counter) {
	//scr->counter = scr->num; /* reset counter */
    }
}

static void sc_crop_change(sc *obj, gint *pos)
{
    gint crop;
    if ((crop = sc_crop_FETCH(obj, *pos+1))) {
	gint otime = xmms_remote_get_output_time(obj->session);
	if (otime > crop) {
	    gint len = xmms_remote_get_playlist_length(obj->session);
	    gint jump = (len-1) == *pos ? 0 : *pos+1;
	    xmms_remote_set_playlist_pos(obj->session, jump);
	}
    }
}

static void *sc_change_func(void *arg)
{
    sc *obj = (sc *)arg;

    while(1) {
	gint pos = xmms_remote_get_playlist_pos(obj->session);
	gint length = xmms_remote_get_playlist_time(obj->session, pos);

	pthread_testcancel();
	xmms_usleep(350);

	sc_crop_change(obj, &pos);

	if(pos != obj->prev_song || length != obj->prev_len) {
	    sc_lock(obj);
	    obj->prev_song = pos;
	    obj->prev_len = length;
	    sc_unlock(obj);

	    sc_repeat_change(obj, &pos);
	    sc_jtime_change(obj, &pos);
	}
    }
}

#ifdef PERL_SC_HANDLERS
/* XXX need perl-thread-safeness */
static void sc_perl_change(sc *obj, gint pos) {
    gint i;
    
    for (i=0; i<=AvFILL(obj->handlers); i++) {
	dSP;
	SV *sv_session = sv_newmortal();
	SV *sv_pos = sv_newmortal();
	sv_setiv(newSVrv(sv_session, "Xmms::Remote"), 
		 obj->session);
	sv_setiv(sv_pos, pos);

	ENTER;SAVETMPS;
	PUSHMARK(sp);
	XPUSHs(sv_session);
	XPUSHs(sv_pos);
	PUTBACK;
	perl_call_sv(*av_fetch(obj->handlers, i, TRUE), G_DISCARD);
	FREETMPS;LEAVE;
    }
}

static void sc_add_handler(sc *obj, SV *handler)
{
    sc_lock(obj);
    av_push(obj->handlers, SvREFCNT_inc(handler));
    sc_unlock(obj);
}

#endif

static void sc_run(sc *obj)
{
    pthread_create(&obj->thread, NULL, sc_change_func, obj);
}

static void sc_stop(sc *obj)
{
    void *status;
    sc_lock(obj);
    pthread_cancel(obj->thread);
    pthread_join(obj->thread, &status);
#if 0
    if (status != PTHREAD_CANCELED) {
	/* uhhh */
    }
#endif
    sc_unlock(obj);
}

static sc *sc_new(SV *sv_class, gint session)
{
    sc *obj = (sc *)malloc(sizeof(*obj));

    obj->prev_song = -1;
    obj->prev_len = -2;
    obj->session = session;
    obj->jtime  = g_hash_table_new(NULL, NULL);
    obj->repeat = g_hash_table_new(NULL, NULL);
    obj->crop   = g_hash_table_new(NULL, NULL);
    //obj->fade   = g_hash_table_new(NULL, NULL);

#ifdef PERL_SC_HANDLERS
    obj->handlers = newAV();
#endif

    return obj;
}

static gboolean hash_rm_gint(gpointer key, gpointer val, gpointer data)
{
    return 1;
}

static gboolean hash_rm_alloc(gpointer key, gpointer val, gpointer data)
{
    free(val);
    return 1;
}

static void sc_clear(sc *obj)
{
    g_hash_table_foreach_remove(obj->jtime, hash_rm_gint, NULL);
    g_hash_table_foreach_remove(obj->repeat, hash_rm_alloc, NULL);
    g_hash_table_foreach_remove(obj->crop, hash_rm_gint, NULL);
}

static void sc_repeat_reset_func(gpointer key, gpointer val, gpointer data)
{
    ((sc_repeat *)val)->counter = ((sc_repeat *)val)->num;
}

static void sc_repeat_reset(sc *obj)
{
    sc_lock(obj);
    g_hash_table_foreach(obj->repeat, sc_repeat_reset_func, NULL);
    sc_unlock(obj);
}

static void sc_DESTROY(sc *obj)
{
#if 0
    /* hrm, core dumpage here
     * but we only ever have on Xmms::SongChange object alive
     * so nothing "leaks"
     */
    sc_stop(obj);
    g_hash_table_destroy(obj->jtime);
    g_hash_table_destroy(obj->repeat);
    g_hash_table_destroy(obj->crop);
    //g_hash_table_destroy(obj->fade);
#endif
#ifdef PERL_SC_HANDLERS
    SvREFCNT_dec(obj->handlers);
#endif
}

#line 294 "SongChange.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
            Perl_croak(aTHX_ "Usage: %s::%s(%s)", hvname, gvname, params);
        else
            Perl_croak(aTHX_ "Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
        Perl_croak(aTHX_ "Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#ifdef PERL_IMPLICIT_CONTEXT
#define croak_xs_usage(a,b)    S_croak_xs_usage(aTHX_ a,b)
#else
#define croak_xs_usage        S_croak_xs_usage
#endif

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#line 436 "SongChange.c"

XS_EUPXS(XS_Xmms__SongChange_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Xmms__SongChange_new)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "sv_class, session=0");
    {
	SV *	sv_class = ST(0)
;
	Xmms__Remote	session;
	Xmms__SongChange	RETVAL;

	if (items < 2)
	    session = 0;
	else {
	    if (SvROK(ST(1)) && sv_derived_from(ST(1), "Xmms::Remote")) {
		IV tmp = SvIV((SV*)SvRV(ST(1)));
		session = INT2PTR(Xmms__Remote,tmp);
	    }
	    else
		Perl_croak(aTHX_ "%s: %s is not of type %s",
			    "Xmms::SongChange::new",
			    "session", "Xmms::Remote")
;
	}

	RETVAL = sc_new(sv_class, session);
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Xmms::SongChange", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Xmms__SongChange_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Xmms__SongChange_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "obj");
    {
	Xmms__SongChange	obj;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    obj = INT2PTR(Xmms__SongChange,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not a reference",
			"Xmms::SongChange::DESTROY",
			"obj")
;

	sc_DESTROY(obj);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Xmms__SongChange_run); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Xmms__SongChange_run)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "obj");
    {
	Xmms__SongChange	obj;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Xmms::SongChange")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    obj = INT2PTR(Xmms__SongChange,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Xmms::SongChange::run",
			"obj", "Xmms::SongChange")
;

	sc_run(obj);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Xmms__SongChange_stop); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Xmms__SongChange_stop)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "obj");
    {
	Xmms__SongChange	obj;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Xmms::SongChange")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    obj = INT2PTR(Xmms__SongChange,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Xmms::SongChange::stop",
			"obj", "Xmms::SongChange")
;

	sc_stop(obj);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Xmms__SongChange_jtime_FETCH); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Xmms__SongChange_jtime_FETCH)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "obj, key");
    {
	Xmms__SongChange	obj;
	gint	key = (gint)SvIV(ST(1))
;
#line 324 "SongChange.xs"
    gint jtime;
    char buf[16];

#line 561 "SongChange.c"
	char *	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Xmms::SongChange")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    obj = INT2PTR(Xmms__SongChange,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Xmms::SongChange::jtime_FETCH",
			"obj", "Xmms::SongChange")
;
#line 328 "SongChange.xs"
    if (!(jtime = sc_jtime_FETCH(obj, key))) {
	XSRETURN_UNDEF;
    }
    time_to_string(jtime, buf);
    RETVAL = buf;

#line 581 "SongChange.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Xmms__SongChange_jtime_STORE); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Xmms__SongChange_jtime_STORE)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "obj, key, val");
    {
	Xmms__SongChange	obj;
	gint	key = (gint)SvIV(ST(1))
;
	char *	val = (char *)SvPV_nolen(ST(2))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Xmms::SongChange")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    obj = INT2PTR(Xmms__SongChange,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Xmms::SongChange::jtime_STORE",
			"obj", "Xmms::SongChange")
;

	sc_jtime_STORE(obj, key, val);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Xmms__SongChange_repeat_STORE); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Xmms__SongChange_repeat_STORE)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "obj, key, val");
    {
	Xmms__SongChange	obj;
	gint	key = (gint)SvIV(ST(1))
;
	gint	val = (gint)SvIV(ST(2))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Xmms::SongChange")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    obj = INT2PTR(Xmms__SongChange,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Xmms::SongChange::repeat_STORE",
			"obj", "Xmms::SongChange")
;

	sc_repeat_STORE(obj, key, val);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Xmms__SongChange_repeat_FETCH); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Xmms__SongChange_repeat_FETCH)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "obj, key");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Xmms__SongChange	obj;
	gint	key = (gint)SvIV(ST(1))
;
#line 355 "SongChange.xs"
    sc_repeat *scr;

#line 661 "SongChange.c"

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Xmms::SongChange")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    obj = INT2PTR(Xmms__SongChange,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Xmms::SongChange::repeat_FETCH",
			"obj", "Xmms::SongChange")
;
#line 358 "SongChange.xs"
    if (!(scr = sc_repeat_FETCH(obj, key))) {
	XSRETURN_UNDEF;
    }
    XPUSHs(sv_2mortal(newSViv(scr->num)));
    if (GIMME == G_ARRAY) {
	XPUSHs(sv_2mortal(newSViv(scr->counter)));
    }
#line 680 "SongChange.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Xmms__SongChange_crop_STORE); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Xmms__SongChange_crop_STORE)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "obj, key, val");
    {
	Xmms__SongChange	obj;
	gint	key = (gint)SvIV(ST(1))
;
	char *	val = (char *)SvPV_nolen(ST(2))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Xmms::SongChange")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    obj = INT2PTR(Xmms__SongChange,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Xmms::SongChange::crop_STORE",
			"obj", "Xmms::SongChange")
;

	sc_crop_STORE(obj, key, val);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Xmms__SongChange_crop_FETCH); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Xmms__SongChange_crop_FETCH)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "obj, key");
    {
	Xmms__SongChange	obj;
	gint	key = (gint)SvIV(ST(1))
;
#line 378 "SongChange.xs"
    gint ctime;
    char buf[16];

#line 730 "SongChange.c"
	char *	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Xmms::SongChange")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    obj = INT2PTR(Xmms__SongChange,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Xmms::SongChange::crop_FETCH",
			"obj", "Xmms::SongChange")
;
#line 382 "SongChange.xs"
    if (!(ctime = sc_crop_FETCH(obj, key))) {
	XSRETURN_UNDEF;
    }
    time_to_string(ctime, buf);
    RETVAL = buf;

#line 750 "SongChange.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Xmms__SongChange_clear); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Xmms__SongChange_clear)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "obj");
    {
	Xmms__SongChange	obj;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Xmms::SongChange")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    obj = INT2PTR(Xmms__SongChange,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Xmms::SongChange::clear",
			"obj", "Xmms::SongChange")
;

	sc_clear(obj);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Xmms__SongChange_repeat_reset); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Xmms__SongChange_repeat_reset)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "obj");
    {
	Xmms__SongChange	obj;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Xmms::SongChange")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    obj = INT2PTR(Xmms__SongChange,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Xmms::SongChange::repeat_reset",
			"obj", "Xmms::SongChange")
;

	sc_repeat_reset(obj);
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Xmms__SongChange); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Xmms__SongChange)
{
    dVAR; dXSARGS;
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#endif
    XS_VERSION_BOOTCHECK;

        newXS("Xmms::SongChange::new", XS_Xmms__SongChange_new, file);
        newXS("Xmms::SongChange::DESTROY", XS_Xmms__SongChange_DESTROY, file);
        newXS("Xmms::SongChange::run", XS_Xmms__SongChange_run, file);
        newXS("Xmms::SongChange::stop", XS_Xmms__SongChange_stop, file);
        newXS("Xmms::SongChange::jtime_FETCH", XS_Xmms__SongChange_jtime_FETCH, file);
        newXS("Xmms::SongChange::jtime_STORE", XS_Xmms__SongChange_jtime_STORE, file);
        newXS("Xmms::SongChange::repeat_STORE", XS_Xmms__SongChange_repeat_STORE, file);
        newXS("Xmms::SongChange::repeat_FETCH", XS_Xmms__SongChange_repeat_FETCH, file);
        newXS("Xmms::SongChange::crop_STORE", XS_Xmms__SongChange_crop_STORE, file);
        newXS("Xmms::SongChange::crop_FETCH", XS_Xmms__SongChange_crop_FETCH, file);
        newXS("Xmms::SongChange::clear", XS_Xmms__SongChange_clear, file);
        newXS("Xmms::SongChange::repeat_reset", XS_Xmms__SongChange_repeat_reset, file);
#if (PERL_REVISION == 5 && PERL_VERSION >= 9)
  if (PL_unitcheckav)
       call_list(PL_scopestack_ix, PL_unitcheckav);
#endif
    XSRETURN_YES;
}

